@ECHO OFF
:::::::::::::::::::::::::::::::::::::::::::::::::::
::
:: Script for generating a PNG image
::
:: Jean-Christophe D., July 29, 2010
:::::::::::::::::::::::::::::::::::::::::::::::::::

:: PARAMETERS
:: DPI image's resolution
set DPIres=600



:: Please don't touch anything else!...

:: Verify parameter %1
SET myLilyFile=%1
IF ERRORLEVEL 2 GOTO _filerror
IF ERRORLEVEL 1 GOTO _nofile

:::::: If %1 was given and path to program does exist...

:: Reach (%1) file's drive
%~d1
IF ERRORLEVEL 1 GOTO _fileano1
:: Reach (%1) file's directory
cd "%~p1"
IF ERRORLEVEL 1 GOTO _fileano2

:: Prepare launching...
ECHO.
ECHO.
:: Show LilyPond's version
ECHO Your current version of LilyPond is:
lilypond.exe -v
IF ERRORLEVEL 1 GOTO _pgmerror1
ECHO.
ECHO.
ECHO                LilyPond is working, please wait...
ECHO.
ECHO.
:: Launch LilyPond
lilypond.exe -d backend=eps -f png -dresolution=%DPIres% %1  1>"%~n1.ano.log"  2>"%~n1.log"
IF ERRORLEVEL 1 GOTO _pgmerror2
GOTO deltmpfiles

:::::: If launching LilyPond gives an unknown error...

:_pgmerror2
ECHO.
ECHO.
ECHO           Welcome to LilyPond PNG score generator! (for Windows...)
ECHO.
ECHO.
ECHO           Sorry, but LilyPond returns an unexpected error on launching.
ECHO.
ECHO           ERRORLEVEL: %ERRORLEVEL%
ECHO.
ECHO.
PAUSE
GOTO deltmpfiles

:::::: If displaying LilyPond's version gives an unknown error...

:_pgmerror1
ECHO.
ECHO.
ECHO           Welcome to LilyPond PNG score generator! (for Windows...)
ECHO.
ECHO.
ECHO           Sorry, but LilyPond returns an unexpected error on displaying version.
ECHO.
ECHO           ERRORLEVEL: %ERRORLEVEL%
ECHO.
ECHO.
PAUSE
GOTO deltmpfiles

:::::: If searching for drive of (%1) gives an error...

:_fileano2
ECHO.
ECHO.
ECHO           Welcome to LilyPond PNG score generator! (for Windows...)
ECHO.
ECHO.
ECHO           Sorry, but searching for the file %1 returns an unexpected error.
ECHO           (problem with directory "%~p1" on drive %~d1)
ECHO.
ECHO           ERRORLEVEL: %ERRORLEVEL%
ECHO.
ECHO.
PAUSE
GOTO deltmpfiles

:::::: If searching for drive of (%1) gives an error...

:_fileano1
ECHO.
ECHO.
ECHO           Welcome to LilyPond PNG score generator! (for Windows...)
ECHO.
ECHO.
ECHO           Sorry, but searching for the file %1 returns an unexpected error.
ECHO           (problem with drive %~d1)
ECHO.
ECHO           ERRORLEVEL: %ERRORLEVEL%
ECHO.
ECHO.
PAUSE
GOTO deltmpfiles

:::::: If no parameter (%1) was given...

:_nofile
ECHO.
ECHO.
ECHO           Welcome to LilyPond PNG score generator! (for Windows...)
ECHO.
ECHO.
ECHO           This .bat launcher allows you to get your music as a PNG image.
ECHO.
ECHO           Parameters were taken from OOoLilyPond generator. You may
ECHO           change the image definition (DPI), inside the script, at the
ECHO           beginning.
ECHO.
ECHO           This .bat file has to be placed in your LilyPond's documents
ECHO           directory.
ECHO.
ECHO           Then you just need to drag and drop your LilyPond's music
ECHO           file on this ".bat" file with your mouse!
ECHO.
ECHO           Enjoy!
ECHO.
ECHO.
PAUSE
GOTO deltmpfiles

:::::: If parameter (%1) verification gives an unexpected error...

:_filerror
ECHO.
ECHO.
ECHO           Welcome to LilyPond PNG score generator! (for Windows...)
ECHO.
ECHO.
ECHO           Sorry, but file verification returns an unexpected error.
ECHO.
ECHO           ERRORLEVEL: %ERRORLEVEL%
ECHO.
ECHO.
PAUSE
GOTO deltmpfiles

:deltmpfiles
IF EXIST "%~n1.eps" del "%~n1.eps"
IF EXIST "%~n1-1.eps" del "%~n1-1.eps"
IF EXIST "%~n1-systems.count" del "%~n1-systems.count"
IF EXIST "%~n1-systems.tex" del "%~n1-systems.tex"
IF EXIST "%~n1-systems.texi" del "%~n1-systems.texi"
:: parameter will become %1 in called function
CALL :delemptyano "%~n1.ano.log"

:: goto end of file and go out
GOTO :EOF

:: --------------------------------------

%% Delete "file".ano.log only if empty
:delemptyano
IF %~z1==0 DEL %1
:: end sub "delemptyano"
GOTO :EOF
